package com.softcream.archosx.dicomparser;

import java.io.File;
import java.util.ArrayList;
/**
 * ArchOSx™ tool DIKOCM Parser copyright (C) 2020 SoftCream Software, Ltd - All Rights Reserved
 * PixelMed™ Java DICOM Toolkit copyright (C)The toolkit is open source and made freely available for both non-commercial and commercial use, under BSD License terms described here https://www.pixelmed.com/
 * Unauthorized copying of this file, via any medium is strictly prohibited
 * Proprietary and confidential
 * Written by:
 * Robert Smietanka robert@softcream.pl
 **/


public class FileList {

    private String fileName;
    private String fileDirectory = System.getProperty("user.dir");;
    private String fileExtension= ".dcm";
    private ArrayList<String> files = new ArrayList<String>();
    private GenericExtensionFilter filter = new GenericExtensionFilter(fileExtension);

    public FileList()  {
        this.fileName = fileName;
        this.fileDirectory = fileDirectory;
        this.fileExtension = fileExtension;
        this.files = files;
        this.filter = filter;


        File dir = new File( fileDirectory );
        if (!dir.isDirectory()) {
            System.out.println("Directory does not exists: " + fileDirectory);
        }

        String[] list = dir.list(filter);

        assert list != null;
        if (list.length == 0) {
            System.out.println("No files found in current directory!");
        }

        for (String file : list) {
            String temp = fileDirectory + File.separator + file;
            this.files.add(temp);

        }

    }


    public String getFileName(int fileIndex) {
        ArrayList<String> files = new ArrayList<String>();
        // GenericExtensionFilter filter = new GenericExtensionFilter(fileExtension);

        File dir = new File( fileDirectory );
        if (!dir.isDirectory()) {
            System.out.println("Directory does not exists: " + fileDirectory);
        }

        String[] list = dir.list(filter);

        assert list != null;
        if (list.length == 0) {
            System.out.println("No files found in current directory!");
        }

        for (String file : list) {
            String temp = fileDirectory + File.separator + file;
            files.add(temp);
        }


        return fileName = files.get(fileIndex);

    }



    public String getFileDirectory() {
        return fileDirectory;
    }

    public void setFileDirectory(String fileDirectory) {
        this.fileDirectory = fileDirectory;
    }

    public ArrayList<String> getFiles() {
        return files;
    }

    public void setFiles(ArrayList<String> files) {
        this.files = files;
    }

    public String getFileExtension() {
        return fileExtension;
    }

    public void setFileExtension(String fileExtension) {
        this.fileExtension = fileExtension;
    }

    public GenericExtensionFilter getFilter() {
        return filter;
    }

    public void setFilter(GenericExtensionFilter filter) {
        this.filter = filter;
    }
}
